<template>
  <ResizePageWrapper :hasLeft="false">
    <template #resizeRight>
      <BasicTable
        @register="registerTable"
        isMenuTable
        ref="tableRef"
        :row-selection="{ selectedRowKeys: selectedKeys, onChange: onSelectChange }"
      >
        <template #toolbar>
          <template v-for="button in tableButtonConfig" :key="button.code">
            <a-button v-if="button.isDefault" type="primary" @click="buttonClick(button.code)">
              <template #icon>
                <Icon :icon="button.icon" />
              </template>
              {{ button.name }}
            </a-button>
            <CustomButtonModal v-else-if="button.buttonType == 'modal'" :info="button" />
            <a-button
              v-else
              :type="button.buttonType === 'danger' ? 'default' : button.buttonType || 'primary'"
              :danger="button.buttonType === 'danger'"
            >
              <template #icon>
                <Icon :icon="button.icon" />
              </template>
              {{ button.name }}
            </a-button>
          </template>
        </template>
        <template #bodyCell="{ column, record }">
          <template v-if="column.dataIndex === 'action'">
            <TableAction
              :actions="getLessActions(record)"
              :dropDownActions="getMoreActions(record)"
            />
          </template>

          <template v-else-if="column.dataIndex && column?.listStyle">
            <span :style="executeListStyle(getValue(record, column, 'style'), column?.listStyle)">{{
              getValue(record, column, 'value')
            }}</span>
          </template>
        </template>
      </BasicTable>
    </template>

    <BfccgrkModal
      @register="registerModal"
      @success="handleFormSuccess"
      @cancel="handleFormCancel"
    />

    <ExportModal
      v-if="visibleExport"
      @close="visibleExport = false"
      :columns="columns"
      @success="handleExportSuccess"
    />
  </ResizePageWrapper>
</template>
<script lang="ts" setup>
  import { ref, computed, provide, Ref, createVNode } from 'vue';

  import { Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import { BasicTable, useTable, TableAction, ActionItem } from '/@/components/Table';
  import {
    getMesWarehouseInPage,
    deleteMesWarehouseIn,
    exportMesWarehouseIn,
  } from '/@/api/ckgl/bfccgrk';
  import { ResizePageWrapper } from '/@/components/Page';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { usePermission } from '/@/hooks/web/usePermission';
  import CustomButtonModal from '/@/components/Form/src/components/CustomButtonModal.vue';
  import { executeListStyle, getValue } from '/@/hooks/web/useListStyle'; //列表样式配置
  import { useRouter } from 'vue-router';

  import printJS from 'print-js';

  import { useModal } from '/@/components/Modal';

  import BfccgrkModal from './components/BfccgrkModal.vue';

  import { downloadByData } from '/@/utils/file/download';
  import ExportModal from '/@/views/form/template/components/ExportModal.vue';

  import { searchFormSchema, columns } from './components/config';

  import Icon from '/@/components/Icon/index';

  import { generateTableJson } from '/@/utils/event/design';

  const listSpliceNum = ref(3); //操作列最先展示几个

  import { useConcurrentLock } from '/@/hooks/web/useConcurrentLock';

  const pageParamsInfo = ref<any>({});
  const {
    enableLockeData,
    handleOpenFormEnableLockeData,
    handleCloseFormEnableLocke,
    handleHasEnableLocke,
  } = useConcurrentLock();

  const { notification } = useMessage();
  const { t } = useI18n();
  defineEmits(['register']);
  const { filterColumnAuth, filterButtonAuth, hasPermission } = usePermission();

  const filterColumns = filterColumnAuth(columns);
  const tableRef = ref();

  const visibleExport = ref(false);

  //展示在列表内的按钮
  const actionButtons = ref<string[]>(['view', 'edit', 'delete']);
  const buttonConfigs = computed(() => {
    const list = [
      {
        buttonId: '2011687510413426688',
        name: '查看',
        code: 'view',
        icon: 'ant-design:eye-outlined',
        isDefault: true,
        isUse: true,
      },
      {
        buttonId: '2011687510413426690',
        name: '编辑',
        code: 'edit',
        icon: 'ant-design:form-outlined',
        isDefault: true,
        isUse: true,
        isEnableLock: true,
      },
      {
        buttonId: '2011729952881885184',
        name: '打印',
        code: 'print',
        icon: 'ant-design:printer-outlined',
        isDefault: true,
        isUse: true,
      },
      {
        buttonId: '2011691871017484288',
        name: '快速导出',
        code: 'export',
        icon: 'ant-design:export-outlined',
        isDefault: true,
        isUse: true,
      },
      {
        buttonId: '2011691871017484289',
        name: '提交',
        code: 'commit',
        icon: 'ant-design:arrow-up-outlined',
        isDefault: false,
        isUse: true,
        setting: [],
        showType: 'top',
        buttonType: 'primary',
      },
      {
        buttonId: '2011687510413426691',
        name: '删除',
        code: 'delete',
        icon: 'ant-design:delete-outlined',
        isDefault: true,
        isUse: true,
      },
    ];
    return filterButtonAuth(list);
  });

  const tableButtonConfig = computed(() => {
    return buttonConfigs.value?.filter((x) => !actionButtons.value.includes(x.code));
  });

  const actionButtonConfig = computed(() => {
    return buttonConfigs.value?.filter((x) => actionButtons.value.includes(x.code));
  });

  const btnEvent = {
    view: handleView,
    edit: handleEdit,
    print: handlePrint,
    export: handleExport,
    delete: handleDelete,
  };

  const { currentRoute } = useRouter();

  const formIdComputedRef = computed(() => currentRoute.value.meta.formId as string);
  provide<Ref<string>>('currentFormId', formIdComputedRef);

  const selectedKeys = ref<string[]>([]);
  const selectedRowsData = ref<any[]>([]);

  const [registerModal, { openModal }] = useModal();

  const [registerTable, { reload, getRawDataSource }] = useTable({
    title: 'Bfccgrk列表',
    api: getMesWarehouseInPage,
    rowKey: 'id',
    columns: filterColumns,
    pagination: {
      pageSize: 10,
    },
    formConfig: {
      labelWidth: 100,
      schemas: searchFormSchema,
      fieldMapToTime: [['djrq', ['djrqStart', 'djrqEnd'], 'YYYY-MM-DD HH:mm:ss ', true]],
      showResetButton: false,
    },
    bordered: false,
    beforeFetch: (params) => {
      pageParamsInfo.value = { ...params, FormId: formIdComputedRef.value, PK: 'id' };
      return pageParamsInfo.value;
    },
    afterFetch: (res) => {
      selectedKeys.value = [];
      selectedRowsData.value = [];
    },
    useSearchForm: true,
    showTableSetting: true,

    striped: false,
    actionColumn: {
      width: 195,
      title: '操作',
      dataIndex: 'action',
      slots: { customRender: 'action' },
    },
    tableSetting: {
      size: false,
    },
    customRow,
    isAdvancedQuery: false,
    querySelectOption: JSON.stringify(searchFormSchema),
    objectId: formIdComputedRef.value, ////系统表单formId,自定义表单releaseId的id值
  });

  function buttonClick(code) {
    btnEvent[code]();
  }

  async function handleEdit(record: Recordable) {
    let field = 'id';
    try {
      let hasIn = handleHasEnableLocke(buttonConfigs.value, 'edit');
      if (hasIn) {
        let res = await handleOpenFormEnableLockeData(record[field], formIdComputedRef.value);
        if (res !== null) {
          return;
        }
      }

      let info = {
        id: record[field],

        isUpdate: true,
      };

      openModal(true, info);
    } catch (error) {}
  }

  function handleDelete(record: Recordable) {
    deleteList([record.id]);
  }

  function deleteList(ids) {
    Modal.confirm({
      title: '提示信息',
      icon: createVNode(ExclamationCircleOutlined),
      content: '是否确认删除？',
      okText: '确认',
      cancelText: '取消',
      onOk() {
        deleteMesWarehouseIn(ids).then((_) => {
          handleSuccess();
          notification.success({
            message: 'Tip',
            description: t('删除成功！'),
          });
        });
      },
      onCancel() {},
    });
  }

  async function handlePrint() {
    const dataSource = Array.isArray(getRawDataSource())
      ? getRawDataSource()
      : getRawDataSource().list;
    const json = generateTableJson(filterColumns, dataSource);
    const properties = filterColumns.map((item) => item.title);
    printJS({
      printable: json,
      properties: properties,
      type: 'json',
    });
  }

  function onSelectChange(selectedRowKeys: [], selectedRows) {
    selectedKeys.value = selectedRowKeys;
    selectedRowsData.value = selectedRows;
  }

  function customRow(record: Recordable) {
    return {
      onClick: () => {
        let selectedRowKeys = [...selectedKeys.value];
        if (selectedRowKeys.indexOf(record.id) >= 0) {
          let index = selectedRowKeys.indexOf(record.id);
          selectedRowKeys.splice(index, 1);
        } else {
          selectedRowKeys.push(record.id);
        }
        selectedKeys.value = selectedRowKeys;
      },
      ondblclick: () => {
        if (record.isCanEdit && hasPermission('bfccgrk:edit')) {
          handleEdit(record);
        }
      },
    };
  }

  function handleSuccess() {
    selectedKeys.value = [];
    selectedRowsData.value = [];
    reload();
  }

  function handleFormSuccess() {
    handleSuccess();
    handleCloseFormEnableLocke(buttonConfigs.value, 'edit');
  }

  function handleFormCancel() {
    handleCloseFormEnableLocke(buttonConfigs.value, 'edit');
  }

  function handleView(record: Recordable) {
    let info = {
      isView: true,
      id: record.id,
    };

    openModal(true, info);
  }

  async function handleExport() {
    visibleExport.value = true;
  }

  async function handleExportSuccess(cols) {
    const res = await exportMesWarehouseIn({
      isTemplate: false,
      columns: cols.toString(),
      ...pageParamsInfo.value,
    });
    visibleExport.value = false;
    downloadByData(
      res.data,
      'Bfccgrk.xlsx',
      'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
    );
    reload();
  }

  function getLessActions(record: Recordable) {
    let list = getActions(record);
    return list.slice(0, listSpliceNum.value);
  }

  function getMoreActions(record: Recordable) {
    let list = getActions(record);
    return list.slice(listSpliceNum.value);
  }

  function getActions(record: Recordable): ActionItem[] {
    record.isCanEdit = false;

    let actionsList: ActionItem[] = [];
    actionButtonConfig.value?.map((button) => {
      if (!record?.workflowData?.processId) {
        record.isCanEdit = true;
        actionsList.push({
          ...button,

          auth: `bfccgrk:${button.code}`,
          label: button?.name,
          color: button.code === 'delete' ? 'error' : undefined,
          onClick: btnEvent[button.code]?.bind(null, record),
        });
      } else {
        if (!['edit', 'delete'].includes(button.code)) {
          actionsList.push({
            auth: `bfccgrk:${button.code}`,
            label: button?.name,
            onClick: btnEvent[button.code]?.bind(null, record),
          });
        }
      }
    });
    return actionsList;
  }
</script>
<style lang="less" scoped>
  :deep(.ant-table-selection-col) {
    width: 50px;
  }

  .show {
    display: flex;
  }

  .hide {
    display: none !important;
  }
</style>
